<?php
/**
 * @name		Template Creator CK
 * @package		com_templateck
 * @copyright	Copyright (C) 2013. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - https://www.template-creator.com - https://www.joomlack.fr
 */
// No direct access to this file
defined('TCK_LOADED') or die('Restricted access');
$expertmode = $this->input->get('expertmode', false);
$joomlaversion = $this->input->get('joomlaversion', false);
?>

<div id="ckinterfaceparams" class="ckinterfacesliderparent">
	<?php TemplateckHelper::renderInterfaceMainTitle(TCK_Text::_('CK_PAGE'), 'fa-cog') ?>
	<div class="ckleftpanel-tools">
		<span class="ckbutton cksave ckleftpanelheadericon-apply ckhastip" title="<?php echo TCK_Text::_('CK_APPLY'); ?>" onclick="ckRenderCss('body', $ck('#ckinterfaceparams'));"><span class="fa fa-check"></span></span>
	</div>
	<div class="ckinterfacesliderlinks">
		<div class="ckinterfacesliderlink" tab="tab_page_infos" ><?php echo TCK_Text::_('CK_GLOBALINFOS_INFOS') ?></div>
		<div class="ckinterfacesliderlink" tab="tab_page_settings" ><?php echo TCK_Text::_('CK_SETTINGS') ?></div>
		<div class="ckinterfacesliderlink" tab="tab_blocstyles" ><?php echo TCK_Text::_('CK_MAIN') ?></div>
		<div class="ckinterfacesliderlink" tab="tab_titlestyles" ><?php echo TCK_Text::_('CK_TITLES') ?></div>
		<div class="ckinterfacesliderlink" tab="tab_buttonstyles" ><?php echo TCK_Text::_('CK_BUTTONS_AND_FORMS') ?></div>
		<div class="ckinterfacesliderlink" tab="tab_contentstyles" ><?php echo TCK_Text::_('CK_CONTENT') ?></div>
		<div class="ckinterfacesliderlink" tab="tab_systemimagesstyles" ><?php echo TCK_Text::_('CK_SYSTEMIMAGES') ?></div>
		<?php if (TEMPLATECREATORCK_PLATFORM == 'joomla') { ?>
		<div class="ckinterfacesliderlink" tab="tab_customimages"><?php echo TCK_Text::_('CK_CUSTOMIMAGES'); ?></div>
		<?php } ?>
	</div>
	<div class="ckinterfaceslidercontent">
		<div class="ckinterfaceslider" data-id="tab_page_infos" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_GLOBALINFOS_INFOS') ?>
			<div class="inner">
				
			</div>
		</div>
		<div class="ckinterfaceslider ckproperty" data-id="tab_page_settings" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_SETTINGS') ?>
			<div class="inner">
				<?php echo $this->interface->createWrapperStyles('bloc', $joomlaversion); ?>
				<div class="ckclr"></div>
			</div>
		</div>
		<div class="ckinterfaceslider ckproperty" data-id="tab_blocstyles" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_MAIN') ?>
			<div class="inner">
				<?php echo $this->interface->createBlocStyles('bloc', 'body', $expert = false, $showlinks = true, $joomlaversion); ?>
				<div class="ckinterfaceblock">
					<div class="ckinterfaceblocktitle"><?php echo TCK_Text::_('CK_VIDEO_BACKGROUND') ?></div>
					<div class="ckinterfaceblockaccordion">
						<div class="ckproperty" data-id="tab_videobgstylesparams">
							<?php echo $this->interface->createVideobgStyles('bloc'); ?>
						</div>
					</div>
				</div>
				<div class="ckclr"></div>
			</div>
		</div>
		<div class="ckinterfaceslider ckproperty" data-id="tab_titlestyles" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_TITLES') ?>
			<div class="inner">
				<div class="ckinterfacesliderlinks">
					<div class="ckinterfacesliderlink" tab="tab_titleh1styles" ><?php echo TCK_Text::_('CK_H1') ?></div>
					<div class="ckinterfacesliderlink" tab="tab_titleh2styles" ><?php echo TCK_Text::_('CK_H2') ?></div>
					<div class="ckinterfacesliderlink" tab="tab_titleh3styles" ><?php echo TCK_Text::_('CK_H3') ?></div>
					<div class="ckinterfacesliderlink" tab="tab_titleh4styles" ><?php echo TCK_Text::_('CK_H4') ?></div>
					<div class="ckinterfacesliderlink" tab="tab_titleh5styles" ><?php echo TCK_Text::_('CK_H5') ?></div>
					<div class="ckinterfacesliderlink" tab="tab_titleh6styles" ><?php echo TCK_Text::_('CK_H6') ?></div>
				</div>
				<div class="ckinterfaceslidercontent">
					<div class="ckinterfaceslider" data-id="tab_titleh1styles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_H1') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('h1title'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_titleh2styles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_H2') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('h2title'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_titleh3styles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_H3') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('h3title'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_titleh4styles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_H4') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('h4title'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_titleh5styles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_H5') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('h5title'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_titleh6styles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_H6') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('h6title'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="ckinterfaceslider ckproperty" data-id="tab_buttonstyles" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_BUTTONS_AND_FORMS') ?>
			<div class="inner">
				<div class="ckinterfacesliderlinks">
					<div class="ckinterfacesliderlink" tab="tab_buttonbuttonnormalstyles" ><?php echo TCK_Text::_('CK_BUTTON'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_NORMALSTATE'); ?></div>
					</div>
					<div class="ckinterfacesliderlink" tab="tab_buttonbuttonhoverstyles" ><?php echo TCK_Text::_('CK_BUTTON'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_HOVERSTATE'); ?></div>
					</div>
					<div class="ckinterfacesliderlink" tab="tab_inputfieldbuttonnormalstyles" ><?php echo TCK_Text::_('CK_INPUTFIELD'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_NORMALSTATE'); ?></div>
					</div>
					<div class="ckinterfacesliderlink" tab="tab_inputfieldbuttonactivestyles" ><?php echo TCK_Text::_('CK_INPUTFIELD'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_FOCUSSTATE'); ?></div>
					</div>
					<div class="ckinterfacesliderlink" tab="tab_readmorebuttonnormalstyles" ><?php echo TCK_Text::_('CK_READMORE'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_NORMALSTATE'); ?></div>
					</div>
					<div class="ckinterfacesliderlink" tab="tab_readmorebuttonhoverstyles" ><?php echo TCK_Text::_('CK_READMORE'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_HOVERSTATE'); ?></div>
					</div>
					<div class="ckinterfacesliderlink" tab="tab_pagenavbuttonnormalstyles" ><?php echo TCK_Text::_('CK_PAGENAV'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_NORMALSTATE'); ?></div>
					</div>
					<div class="ckinterfacesliderlink" tab="tab_pagenavbuttonhoverstyles" ><?php echo TCK_Text::_('CK_PAGENAV'); ?> <div class="ckinterfacetablinkdesc"><?php echo TCK_Text::_('CK_HOVERSTATE'); ?></div>
					</div>
				</div>
				<div class="ckinterfaceslidercontent">
					<div class="ckinterfaceslider" data-id="tab_buttonbuttonnormalstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_BUTTON', 'CK_NORMALSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('buttonbutton', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_buttonbuttonhoverstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_BUTTON', 'CK_HOVERSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('buttonbuttonhover', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_inputfieldbuttonnormalstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_INPUTFIELD', 'CK_NORMALSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('inputfieldbutton', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_inputfieldbuttonactivestyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_INPUTFIELD', 'CK_FOCUSSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('inputfieldbuttonactive', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_readmorebuttonnormalstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_READMORE', 'CK_NORMALSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('readmorebutton', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_readmorebuttonhoverstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_READMORE', 'CK_HOVERSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('readmorebuttonhover', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_pagenavbuttonnormalstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_PAGENAV', 'CK_NORMALSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('pagenavbutton', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider" data-id="tab_pagenavbuttonhoverstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_PAGENAV', 'CK_HOVERSTATE') ?>
						<div class="inner">
							<?php echo $this->interface->createNormalStyles('pagenavbuttonhover', false); ?>
							<div class="ckclr"></div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="ckinterfaceslider" data-id="tab_contentstyles" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_CONTENT') ?>
			<div class="inner">
				<div class="ckinterfacesliderlinks">
					<div class="ckinterfacesliderlink" tab="tab_bulletstyles" ><?php echo TCK_Text::_('CK_BULLET_LIST') ?></div>
					<div class="ckinterfacesliderlink" tab="tab_articledetailsstyles" ><?php echo TCK_Text::_('CK_ARTICLE_DETAILS') ?></div>
					<div class="ckinterfacesliderlink" tab="tab_tablestyles" ><?php echo TCK_Text::_('CK_TABLE') ?></div>
				</div>
				<div class="ckinterfaceslidercontent">
					<div class="ckinterfaceslider ckproperty" data-id="tab_bulletstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_BULLET_LIST') ?>
						<div class="inner">
							<?php echo $this->interface->createBullet('bulletlist'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					<div class="ckinterfaceslider ckproperty" data-id="tab_articledetailsstyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_ARTICLE_DETAILS') ?>
						<div class="inner">
							<?php echo $this->interface->createBlocStyles('articledetails'); ?>
							<div class="ckclr"></div>
						</div>
					</div>
					
					<div class="ckinterfaceslider ckproperty" data-id="tab_tablestyles" style="display: none;">
						<?php TemplateckHelper::renderInterfaceSliderTitle('CK_TABLE') ?>
						<div class="inner">
							<div class="ckinterfaceblock">
				<div class="ckoption">
					<?php $this->interface->createLabel('CK_TABLE_STYLE', 'palette.png') ?>
					<span class="ckoption-field">
						<select class="inputbox" name="tablestyle" id="tablestyle" >
								<option value="none"><?php echo TCK_Text::_('CK_TABLE_NONE'); ?></option>
								<option value="standard"><?php echo TCK_Text::_('CK_TABLE_SIMPLE'); ?></option>
								<option value="bordered"><?php echo TCK_Text::_('CK_TABLE_BORDERED'); ?></option>
							</select>
					</span>
						</div>
				<div class="ckoption">
					<?php $this->interface->createLabel('CK_TABLE_OPTIONS', 'page_white_wrench.png') ?>
					<span class="ckoption-field">
						<select class="inputbox" name="tableoptions" id="tableoptions" >
								<option value="none"><?php echo TCK_Text::_('CK_TABLE_NONE'); ?></option>
								<option value="striped"><?php echo TCK_Text::_('CK_TABLE_STRIPED'); ?></option>
								<option value="hover"><?php echo TCK_Text::_('CK_TABLE_HOVER'); ?></option>
								<option value="stripedhover"><?php echo TCK_Text::_('CK_TABLE_STRIPEDHOVER'); ?></option>
							</select>
					</span>
						</div>
						<div class="ckoption">
					<?php $this->interface->createLabel('CK_TABLEBORDER_STYLE', 'color.png') ?>
					<span class="ckoption-field">
						<input class="inputbox colorPicker" type="text" placeholder="#dddddd" name="tableborderscolor" id="tableborderscolor" />

							<input class="inputbox" style="width:30px;" name="tableborderssize" id="tableborderssize" type="text" placeholder="1"/>
							<select class="inputbox" style="width:78px;height:22px;" name="tablebordersstyle" id="tablebordersstyle" >
								<option value="solid">solid</option>
								<option value="dotted">dotted</option>
								<option value="dashed">dashed</option>
							</select>

					</span>
				</div>
				<div class="ckoption">
					<?php $this->interface->createLabel('CK_TABLEBORDERRADIUS', 'border_radius_tr.png') ?>
					<span class="ckoption-field">
						<input class="inputbox" name="tableborderradius" id="tableborderradius" type="text" placeholder="4"/>
					</span>
				</div>
				<div class="ckoption">
					<?php $this->interface->createLabel('CK_TABLESTRIPED_STYLE', 'color.png') ?>
					<span class="ckoption-field">
						<input class="inputbox colorPicker" type="text" value="#f9f9f9" name="tablestripedcolor" id="tablestripedcolor" />
					</span>
				</div>
				<div class="ckoption">
					<?php $this->interface->createLabel('CK_TABLEHOVER_STYLE', 'color.png') ?>
					<span class="ckoption-field">
						<input class="inputbox colorPicker" type="text" value="#f5f5f5" name="tablehovercolor" id="tablehovercolor" />
					</span>
				</div>
			</div>
						<p></p>
						<div style="clear:both;">
							<?php echo $this->interface->createBackground('table'); ?>
							<?php echo $this->interface->createText('table'); ?>
							<?php echo $this->interface->createDimensions('table', $useheight = false, $usewidth = false, $expert = false, $iswrapper = false, $usemargins = false); ?>
							<?php echo $this->interface->createShadow('table'); ?>
				<br />
						<div style="clear:both;">
							<div class="menupanetitle"><?php echo TCK_Text::_('CK_TABLE_EXAMPLES'); ?></div>
							<div class="menupaneblock" style="margin:5px;">
								<div style="color: #3399FF;font-size: 14px;font-weight: bold;text-transform: uppercase;"><?php echo TCK_Text::_('CK_TABLE_NONE'); ?></div>
						<img src="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/images/table_none.png" width="270" height="85" style="border: 1px solid #3399FF;padding:5px;" />
							</div>
							<div class="menupaneblock" style="margin:5px;">
								<div style="color: #3399FF;font-size: 14px;font-weight: bold;text-transform: uppercase;"><?php echo TCK_Text::_('CK_TABLE_SIMPLE'); ?></div>
						<img src="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/images/table_simple.png" width="270" height="85" style="border: 1px solid #3399FF;padding:5px;" />
							</div>
							<div class="menupaneblock" style="margin:5px;">
								<div style="color: #3399FF;font-size: 14px;font-weight: bold;text-transform: uppercase;"><?php echo TCK_Text::_('CK_TABLE_BORDERED'); ?></div>
						<img src="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/images/table_bordered.png" width="270" height="85" style="border: 1px solid #3399FF;padding:5px;" />
							</div>
							<div class="menupaneblock" style="margin:5px;">
								<div style="color: #3399FF;font-size: 14px;font-weight: bold;text-transform: uppercase;"><?php echo TCK_Text::_('CK_TABLE_STRIPED'); ?></div>
						<img src="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/images/table_striped.png" width="270" height="85" style="border: 1px solid #3399FF;padding:5px;" />
							</div>
						</div>
        </div>
	
							<div class="ckclr"></div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="ckinterfaceslider ckproperty" data-id="tab_systemimagesstyles" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_SYSTEMIMAGES') ?>
			<div class="inner">
				<?php if (TEMPLATECREATORCK_PLATFORM == 'joomla') { ?>
				<div class="ckoption">
					<div><?php echo TCK_Text::_('CK_EMAIL_IMAGE'); ?></div>
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="emailsystemimageurl" id="emailsystemimageurl" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('emailsystemimageurl')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<div><?php echo TCK_Text::_('CK_PRINT_IMAGE'); ?></div>
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="printsystemimageurl" id="printsystemimageurl" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('printsystemimageurl')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<div><?php echo TCK_Text::_('CK_EDIT_IMAGE'); ?></div>
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="editsystemimageurl" id="editsystemimageurl" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('editsystemimageurl')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<div><?php echo TCK_Text::_('CK_ARROW_IMAGE'); ?></div>
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="arrowsystemimageurl" id="arrowsystemimageurl" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('arrowsystemimageurl')" href="javascript:void(0)" >+</a>
				</div>
				<?php } ?>
				<div class="ckoption">
					<div><?php echo TCK_Text::_('CK_FAVICON_IMAGE'); ?></div>
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="faviconsystemimageurl" id="faviconsystemimageurl" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('faviconsystemimageurl')" href="javascript:void(0)" >+</a>
				</div>
				<?php if (TEMPLATECREATORCK_PLATFORM == 'joomla') { ?>
				<div class="ckoption">
				<div><?php echo TCK_Text::_('CK_THUMB_IMAGE'); ?></div>
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="template_thumbnailsystemimageurl" id="template_thumbnailsystemimageurl" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('template_thumbnailsystemimageurl')" href="javascript:void(0)" >+</a>
				</div>
				<?php } ?>
				<div class="ckoption">
					<div><?php echo TCK_Text::_('CK_PREVIEW_IMAGE'); ?></div>
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="template_previewsystemimageurl" id="template_previewsystemimageurl" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('template_previewsystemimageurl')" href="javascript:void(0)" >+</a>
				</div>
			</div>
		</div>
		<?php if (TEMPLATECREATORCK_PLATFORM == 'joomla') { ?>
		<div class="ckinterfaceslider ckproperty" data-id="tab_customimages" style="display: none;">
			<?php TemplateckHelper::renderInterfaceSliderTitle('CK_CUSTOMIMAGES') ?>
			<div class="inner">
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage1" id="customimage1" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage1')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage2" id="customimage2" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage2')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage3" id="customimage3" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage3')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage5" id="customimage5" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage4')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage6" id="customimage6" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage5')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage7" id="customimage7" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage6')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage8" id="customimage8" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage7')" href="javascript:void(0)" >+</a>
				</div>
				<div class="ckoption">
					<input style="height: 18px;vertical-align: baseline;" class="inputbox" type="text" value="" name="customimage9" id="customimage9" /><a class="ckbuttonstyle" onclick="ckCallImageManagerPopup('customimage8')" href="javascript:void(0)" >+</a>
				</div>
			</div>
		</div>
		<?php } ?>
	</div>
</div>
<div style="clear:both;"></div>

<script language="javascript" type="text/javascript">
	ckInitColorPickers();
	ckInitModalPopup();
	ckInitOptionsTabs();
	ckInitOptionsAccordions($ck('#ckinterfaceparams'));
	ckInitOptionsSliders($ck('#ckinterfaceparams'));
</script>