<?php
/**
 * @name		Page Builder CK
 * @package		com_pagebuilderck
 * @copyright	Copyright (C) 2015. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - https://www.template-creator.com - https://www.joomlack.fr
 */

defined('TCK_LOADED') or die;

$input = new TCK_Input();
$prefix = $input->get('prefix', '', 'string');
?>
<link rel="preconnect" href="https://fonts.gstatic.com">
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/assets/ckframework.css" type="text/css" />
<link rel="stylesheet" href="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/assets/font-awesome.min.css" type="text/css" />
<script src="<?php echo TEMPLATECREATORCK_MEDIA_URI ?>/assets/jquery.min.js" type="text/javascript"></script>

<div class="ckinterface" style="padding: 20px;">
	<p>
		<input id ="cksearchfontcategory" name="cksearchfontcategory" type="text" style="height:auto;margin:0;width: 500px;max-width:100%;" onchange="ckSearchFontCategory()" />
		<button class="ckbutton" onclick="ckSearchFontCategory()"><span class="fa fa-search"></span> <?php echo TCK_Text::_('CK_SEARCH') ?></button><i class="fa fa-pulse fa-spinner"></i>
		<button class="ckbutton" onclick="jQuery('#cksearchfontcategory').val('');ckSearchFontCategory();"><span class="fa fa-times"></span> <?php echo TCK_Text::_('CK_CLEAR') ?></button><i class="fa fa-pulse fa-spinner"></i>
		<button class="ckbutton ckbutton-primary" onclick="returngooglefont()"><span class="fa fa-check"></span> <?php echo TCK_Text::_('CK_SELECT') ?></button>
	</p>
	<p>
		<label for=""><?php echo TCK_Text::_('CK_CATEGORY') ?></label>
		<select id="ckselectfontcategory" onchange="ckFilterFontCategory()">
			<option value=""><?php echo TCK_Text::_('CK_ALL') ?></option>
			<option value="sans-serif">sans-serif</option>
			<option value="serif">serif</option>
			<option value="handwriting">handwriting</option>
			<option value="display">display</option>
			<option value="monospace">monospace</option>
		</select></p>
	<div id="ckgooglefontslist" class="ckfontslist"></div>
	<div id="ckgooglefontdetails"></div>
</div>
<script>
// <link href="https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,100;0,300;0,400;1,100&display=swap" rel="stylesheet">
//<link href='https://fonts.googleapis.com/css?family=Open+Sans' rel='stylesheet' type='text/css'>
// <link href='https://fonts.googleapis.com/css?family=Open+Sans&subset=latin,greek-ext' rel='stylesheet' type='text/css'>
//https://fonts.googleapis.com/css?family=Open+Sans
// Open+Sans
// Opens Sans

/*
 var apiUrl = [];
apiUrl.push('https://fonts.googleapis.com/css?family=');
apiUrl.push(anonymousPro.family.replace(/ /g, '+'));
if (contains('italic', anonymousPro.variants)) {
  apiUrl.push(':');
  apiUrl.push('italic');
}
if (contains('greek', anonymousPro.subsets)) {
  apiUrl.push('&subset=');
  apiUrl.push('greek');
}

// url: 'https://fonts.googleapis.com/css?family=Anonymous+Pro:italic&subset=greek'
var url = apiUrl.join('');
 */


/* 
 * Test the given value and search for a google font
 * 
 * return void
 */
function searchgooglefont() {
	var url = jQuery('#googlefonturl').val();
	var name = ckCapitalize(jQuery('#googlefonturl').val()).trim("'");
	if (! url) {
		alert ('<?php echo TCK_Text::_('CK_EMPTY_URL', true) ?>');
		jQuery('#googlefonturl').addClass('invalid').focus();
		return;
	}
	jQuery('.fa-spinner').css('opacity', '1');
	var valuetest = /\+/;
	if ( url.indexOf("specimen") != -1 ) {
		name = url.split('=');
		name = name[1];
		getGooglefontFromFontvalue(name); 	// https://fonts.google.com/specimen/Dancing+Script?selection.family=Dancing+Script
	} else if ( url.indexOf("http") == 0 ) {
		getGooglefontFromUrl(url); 			// https://fonts.googleapis.com/css?family=Open+Sans:400,400italic,600
	} else if ( url.indexOf("<link") == 0 ) {
		getGooglefontFromStylesheet(url); 	// <link href='https://fonts.googleapis.com/css?family=Open+Sans:400,400italic,600' rel='stylesheet' type='text/css'>
	} else if ( valuetest.test(url) ) {
		getGooglefontFromFontvalue(name); 	// Open+Sans
	} else {
		getGooglefontFromFontname(name); 	// Open Sans
	}
}
/* 
 * Load the font stylesheet from its url
 * @param : url - the http path to the stylesheet (https://fonts.googleapis.com/css?family=Open+Sans:400,400italic,600)
 * 
 * return : void
 */
function getGooglefontFromUrl(url) {
	jQuery.ajax({
		url: url,
	})
	.done(function( data ) {
		if (data) {
			jQuery('#googlefontstyle').html('<style>' + data + '</style>');
			var fontName = getNameFromContent(data).replace(/'/g, "");
			if (fontName) {
				jQuery('#fontappliedname').html(fontName);
				var re = /([0-9])*$/;
				var fontWeight = url.match(re);
				console.log(fontWeight);
				if (typeof(fontWeight[0]) != 'undefined') {
					jQuery('#googlefontweight').val(fontWeight[0]);
				}
				jQuery('#fonturl').val(url);
				updateFontPreview(fontName);
			}
		} else {
			alert( '<?php echo TCK_Text::_('CK_FONT_NOT_FOUND', true) ?>' );
		}
		jQuery('.fa-spinner').css('opacity', '0');
	})
	.fail(function() {
		alert( '<?php echo TCK_Text::_('CK_FONT_NOT_FOUND', true) ?>' );
		jQuery('.fa-spinner').css('opacity', '0');
	});
}

/* 
 * Load the font stylesheet from its stylesheet code
 * @param : url - the stylesheet code (<link href='https://fonts.googleapis.com/css?family=Open+Sans&subset=latin,greek-ext' rel='stylesheet' type='text/css'>)
 * 
 * return : String - the stylesheet content
 */
function getGooglefontFromStylesheet(stylesheet) {console.log(stylesheet);
	var re = /href='(.*?)'/;
	var url = stylesheet.match(re);
	if (! url) {
		var re = /href="(.*?)"/;
		var url = stylesheet.match(re);
	}
	if (typeof(url[1]) == 'undefined') {
		alert('<?php echo TCK_Text::_('CK_FONTURL_NOT_FOUND', true) ?>');
		return;
	}
	getGooglefontFromUrl(url[1].trim("'"));
}

/* 
 * Load the font stylesheet from its url
 * @param : url - the http path to the stylesheet (Open+Sans)
 * 
 * return : String - the stylesheet content
 */
function getGooglefontFromFontvalue(name) {
	var url = 'https://fonts.googleapis.com/css?family=' + name;
	getGooglefontFromUrl(url);
}

/* 
 * Load the font stylesheet from its url
 * @param : url - the http path to the stylesheet (Open Sans)
 * 
 * return : String - the stylesheet content
 */
function getGooglefontFromFontname(name) {
	names = name.split(' ');
	for (var i=0; i<names.length ; i++) {
		names[i] = ckCapitalize(names[i]);
	}
	name = names.join('+');
	getGooglefontFromFontvalue(name);
}

/*
 * Extract the name of the font from the google font styles
 * @param content : string - the font styles from google
 *
 * return string - the name
 */
function getNameFromContent(content) {
	// font-family:(.*?);
	var re = /font-family:(.*?);/;
	var fontName = content.match(re);
	if (typeof(fontName[1]) == 'undefined') {
		alert('<?php echo TCK_Text::_('CK_FONTNAME_NOT_FOUND', true) ?>');
		return '';
	}
	return fontName[1].trim().trim("'");
}

/*
 * Apply the font to the preview text
 * @param fontName : string - the font name
 *
 * return void
 */
function updateFontPreview(fontName) {
	jQuery('#fontpreview').css('font-family', fontName);
	updatefontweight();
}

/*
 * Apply the font weight to the preview text
 *
 * return void
 */
function updatefontweight() {
	jQuery('#fontpreview').css('font-weight', jQuery('#googlefontweight').val());
}

/*
 * Get the name and font weight and return them into the parent window
 *
 * return void
 */
function returngooglefont() {
//	if (! jQuery('#fonturl').val()) return;
	window.parent.ckSetGoogleFont('<?php echo $prefix ?>', jQuery('#fonturl').val(), jQuery('#fontappliedname').text(), jQuery('#googlefontweight').val());
	window.parent.CKBox.close();
}

function ckCapitalize(string) {
	return string.charAt(0).toUpperCase() + string.slice(1);
}

/*------------------- new interface -------------------*/
function ckgetFontsLibrary(targetId) {
	var setVar = 'google';
	jQuery('#' + targetId).addClass('ckwait');
	var debug = false;
	sessionStorage.setItem('fonts_library_' + setVar,'');
	if (!debug && window.sessionStorage && sessionStorage.getItem('fonts_library_' + setVar)) {
		var html = sessionStorage.getItem('fonts_library_' + setVar);
		jQuery('#' + targetId).empty().append(html);
		jQuery('#' + targetId).removeClass('ckwait');
		ckAddEventOnIcons();
	} else {
		var url = 'https://media.joomlack.fr/api/fonts/list/google';
		jQuery.ajax({
			url: url,
			dataType: 'jsonp',
			cache: true,
			jsonpCallback: "joomlack_jsonpcallback",
			timeout: 20000,
			success: function (response) {
				jQuery('#' + targetId).removeClass('ckwait');
				var html = '';
				var items = response.items;
				for (var i=0;i<items.length;i++) {
					html += ckFontItemDisplay(items[i]);
				}
				html = '<p class="ckfontslistnumber">' + i + ' fonts found</p>' + html;
				jQuery('#' + targetId).empty().append(html);
//				ckAddEventOnIcons();
				sessionStorage.setItem('fonts_library_' + setVar, html);
				ckScrollFonts();
			},
			fail: function() {
				alert('Error : Unable to connect to the library. Please contact an administrator');
			},
			complete: function() {

			},
			error: function(request, status, error) {

			}
		});
	}
}
ckgetFontsLibrary('ckgooglefontslist');

function ckFontItemDisplay(item) {
	var name = item.family;
	var styles = item.variants;
	var subsets = item.subsets;
	var category = item.category;
	var html = '';
	html += '<div class="ckfontitem" onclick="ckShowFontDetails(this)" loading="lazy" data-font="' + name + '" data-name="' + name.toLowerCase() + '" data-category="' + category + '">'
				+ '<div class="ckfontitem-json">' + JSON.stringify(item) + '</div>'
				+ '<div class="ckfontitem-name">' + name + '</div>'
				+ '<div class="ckfontitem-styles"><span class="ckfontitem-styles-count">' + styles.length + '</span> <?php echo TCK_Text::_('CK_STYLES') ?></div>'
				+ '<div class="ckfontitem-state"></div>'
				+ '<div class="ckfontitem-demo">Almost before we knew it, we had left the ground.</div>'
			+ '</div>';

	return html;
}

function ckScrollFonts() {
	var limit = jQuery(window).scrollTop() + jQuery(window).height();
	var items = jQuery('.ckfontitem:not([data-loaded="1"])');

	items.each(function(i) {
		var $item = jQuery(this);
		var name = $item.attr('data-font');
		var fontfamily = name.replace(/\+/g, ' ');

		if ($item.offset().top < limit) {
			jQuery(document.head).append('<link href="https://fonts.googleapis.com/css2?family=' + name + '" rel="stylesheet">')
			$item.attr('data-loaded', '1');
			$item.find('.ckfontitem-demo').css('font-family', fontfamily).css('color', '#333');
			$item.find('.ckfontitem-state').attr('data-state', '1');
		} else {
			return false;
		}
	});
}

function ckFilterFontCategory() {
	var cat = jQuery('#ckselectfontcategory').val();
	if (! cat) {
		jQuery('.ckfontitem').show();
		return;
	} else {
		jQuery('.ckfontitem').hide();
		jQuery('.ckfontitem[data-category="' + cat + '"]').show();
		ckScrollFonts();
	}
}

function ckSearchFontCategory() {
	var search = jQuery('#cksearchfontcategory').val().trim().toLowerCase();
	if (! search) {
		jQuery('.ckfontitem').show();
		return;
	} else {
		jQuery('.ckfontitem').hide();
		jQuery('.ckfontitem[data-name*="' + search + '"]').show();
		ckScrollFonts();
	}
}

function ckShowFontDetails(item) {
	var $item = jQuery(item);
	var settings = $item.find('.ckfontitem-json').html();
	var settingsObj = JSON.parse(settings);
	console.log(settingsObj);
	jQuery('#ckgooglefontslist').hide();
	var details = ckFontDetailsDisplay(settingsObj);
	jQuery('#ckgooglefontdetails').empty().show().append(details);
}

function ckFontDetailsDisplay(item) {
	var name = item.family;
	var category = item.category;
	var subsets = item.subsets;
	var variants = item.variants;
	var text = 'Almost before we knew it, we had left the ground.';
	var html = '';
	html += '<div class="ckfontitem-details" data-font="' + name + '" data-name="' + name.toLowerCase() + '" data-category="' + category + '">'
				+ '<div class="ckfontitem-details-close ckbutton" onclick="ckBackTofontsList()"><span class="fa fa-chevron-left"></span> <?php echo TCK_Text::_('CK_BACK') ?></div>'
				+ '<div class="ckfontitem-name">' + name + '</div>'
				+ '<div class="ckfontitem-details-styles"><?php echo TCK_Text::_('CK_STYLES') ?></div>'
	for (var i = 0; i < variants.length; i++) {
		var variant = variants[i];
		var fontweight = variant;
		var fontstyle = '';
		if (variant.indexOf('italic') > -1) fontstyle = 'font-style:italic';
		fontweight = variant.replace('italic', '');
		if (fontweight == 'regular') fontweight = '400';
		if (fontweight == '') fontweight = '400';
		var style = 'style="font-family:' + name + ';' + fontstyle + ';font-weight:' + fontweight + ';"'
		html += '<div class="ckfontitem-variant-line">'
			+ '<div class="ckfontitem-variant-detail">' + fontweight + ' ' + fontstyle + '</div>'
			+ '<div class="ckfontitem-variant" ' + style + '>' + text + '</div>'
			+ '</div>'
	}
	html += '</div>';

	return html;
}

function ckBackTofontsList() {
	jQuery('#ckgooglefontdetails').hide();
	jQuery('#ckgooglefontslist').show();
}

jQuery(window).scroll(function() {
	ckScrollFonts();
});
</script>
<style>
	body {
	background: #fff;
}

#fontpreview {
	font-size: 28px;
	display: block;
	line-height: 1.5em;
	padding: 20px 0;
}

label {
	display: inline-block !important;
	min-width: 200px;
}

.fa-spinner {
	opacity: 0;
}

.ckfontslist * {
	box-sizing: border-box;
}

.ckfontslistnumber {
	flex: 1 1 100%;
}

.ckfontitem {
	flex: 1 1 auto;
	min-width: 250px;
	width: 350px;
	cursor: pointer;
	border: 1px solid #ddd;
	border-radius: 5px;
	padding: 15px;
	color: #333;
	font-size: 13px;
	margin: 15px;
	position: relative;
}

.ckfontitem:hover {
	box-shadow: #ccc 0 0 15px;
}

.ckfontslist {
	display: flex;
	flex-wrap: wrap;
}

.ckfontitem-name {
	font-size: 14px;
	color: #444;
}

.ckfontitem-demo {
	font-size: 40px;
	text-align: left;
	line-height: 1;
	margin: 10px 0;
	color: #fff;
}

.ckfontitem-json {
	display: none;
}

.ckfontitem-styles {
	position: absolute;
	right: 50px;
	top: 15px;
	color: #999;
}

.ckfontitem-state {
	position: absolute;
	right: 15px;
	top: 15px;
	width: 10px;
	height: 10px;
	/*background: #ddd;*/
	border-radius: 50%;
}

.ckfontitem-state[data-state="1"] {
	/*background: green;*/
}

.ckfontitem-variant {
	font-size: 60px;
	line-height: 1;
	white-space: nowrap;
	overflow: hidden;
	padding: 10px 0;
	border-top: 1px solid #ddd;
	margin: 10px 0;
}

.ckfontitem-details .ckfontitem-name {
	font-size: 36px;
	line-height: 1;
	margin: 20px;
}

.ckfontitem-details-styles {
	color: #aaa;
	font-size: 20px;
	line-height: 1;
	margin: 5px 0 20px;;
}
</style>